/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';

const requireHook = require('../../hooks/require');
const patcher = require('../../hooks/patcher');
const tracker = require('../../tracker');
const { PATCH_TYPES } = require('../../constants');
const TagRange = require('../models/tag-range');
const tagRangeUtil = require('../models/tag-range/util');
const { CallContext, Signature, PropagationEvent } = require('../models');

module.exports.handle = handle;
module.exports.patchUtilsExport = patchUtilsExport;

/**
 * Called to install require hook.
 */
function handle() {
  requireHook.resolve(
    { name: 'handlebars', file: 'dist/cjs/handlebars/utils' },
    (utils) => {
      module.exports.patchUtilsExport(utils);
    }
  );
}

/**
 * Patch the function to apply html-encoded tag to tracked return values.
 * @param {object} utilsExport The exported value of the utils file
 */
function patchUtilsExport(utilsExport) {
  patcher.patch(utilsExport, 'escapeExpression', {
    name: 'handlebars.utils.escapeExpression',
    patchType: PATCH_TYPES.ASSESS_PROPAGATOR,
    alwaysRun: true,
    post(data) {
      const trackData = tracker.getData(data.result);
      if (trackData) {
        trackData.tagRanges = tagRangeUtil.add(
          trackData.tagRanges,
          new TagRange(0, data.result.length - 1, 'html-encoded')
        );

        const event = new PropagationEvent({
          context: CallContext.create(data),
          parents: [trackData.event],
          signature: new Signature(
            'handlebars/dist/cjs/handlebars/utils.escapeExpression'
          ),
          source: 'P',
          target: 'R',
          tagRanges: trackData.tagRanges
        });
        trackData.event = event;
      }
    }
  });
}
